#ifndef NETWINDOW_H
#define NETWINDOW_H

#ifndef PREFSWINDOW_H
#include "PrefsWindow.h"
#endif

#include "PrefsLib.h"

#define	CANCELOP_MSG	'stop'

#define	PORTFOUND_MSG	'pfms'
#define	PINGDATA_MSG	'pdat'
#define	THREAD_EXIT		'txit'
#define	PINGTHREAD_EXIT	'pxit'
#define HOST_NOT_FOUND_MSG	'hnfm'

class NetWindow : public BWindow {

public:
					NetWindow (BRect frame, char *applocation);
	virtual bool	QuitRequested ();
	virtual	void	MessageReceived (BMessage *message);
	virtual void	FrameResized (float, float);
	virtual void	FrameMoved (BPoint);
private:
	bool			ParseTextField (bool errfail);
	void			DNSLookup ();
	bool			Portscan ();
	void			AboutMenu ();
	void			PrefsMenu ();
	void			PingMaster ();
//	bool			Ping (char *returntxt);
	bool			CheckTCPPort ( int portnum );
	bool			CheckUDPPort ( int portnum );
	void			NetError (const char *text);
	void			NetError (const char *text, const char *extra);
	void			PrefsError (const char *texta, const char *textb);
	void			ReadPrefs ();
	void			WritePrefs ();
	void			WriteWindowMovedPrefs ();
	void			WriteWindowResizedPrefs ();
	void			AddPrefsInt32 (PrefsDB *prefs, char *name, int32 value);
	void			AddPrefsBool (PrefsDB *prefs, char *name, bool value);
	void			AddPrefsBPoint (PrefsDB *prefs, char *name, BPoint value);
	void			NetDebug (const char *text, const char *extra);
	void			GetIP (const char *hostname, bool errfail);
	void			GetName (const char *hostip, bool errfail);
	void			SpawnTCPScanner ();
	void			SpawnUDPScanner ();
	bool			KillTCPScanner ();
	bool			KillUDPScanner ();
	void			KillPinger ();
	
	PrefsWindow		*fPrefsWindow;

	BMenuBar		*fMenuBar;
	BView			*fMainView;
	BTextControl 	*fTextField;
	BTextView		*fStatusTextView;
	BNetAddress		*fHostInfo;
	BScrollView		*fScrollView;
	BStatusBar		*fStatusBar;
	BButton			*fCancelOpButton;
	BString			fStatusText;
	BString			fHostName;
	BString			fHostIP;
	BString			fHostAliases[6];
	BString			fHostAddresses[6];
	BBox			*fMainBB;
	int				num_pings, ping_size;
	int				start_port, end_port;
	bool			pre_ping, udp_scan;
	int				windowx, windowy, windowh, windoww;
	bool			opinprogress;
	int				numtports, numuports;
	BString			fAppLocation;
	
	PrefsDB			*prefs;
};

#endif

