#include "NetTool.h"

void NetWindow::NetError (const char *text) {
	BString		errString (text);
	bool		do_alert_box = true;
	BMessage	*bMessage = new BMessage (HOST_NOT_FOUND_MSG);
	
	switch (h_errno) {
		case HOST_NOT_FOUND:
			do_alert_box = false;
			errString.Append (" : Unknown Host");
			bMessage->AddString ("error_text", errString.String());
			be_app->PostMessage (bMessage);
			break;
		case EADDRINUSE:
			errString.Append (" : Address in use");
			break;
		case ENOTCONN:
			errString.Append (" : Socket Not Connected");
			break;
		case EINTR:
			errString.Append (" : Local Socket Interrupted");
			break;
		default:
			errString.Append (" : Unknown Error");
			break;
	}
	
	if ( do_alert_box == true ) {
		BAlert *alert = new BAlert ("NetError", errString.String (), "OK", NULL, NULL, B_WIDTH_FROM_LABEL, B_WARNING_ALERT);
		alert->Go ();
	}
	fHostIP.Truncate (0, true);
	fHostName.Truncate (0, true);
	for ( int x = 0; x < 6; x++ ) {
		fHostAliases[x].Truncate (0, true);
	}
}

void NetWindow::NetError (const char *text, const char *extra) {
	BString		errString (text);
	
	errString << " : " << extra;
	BAlert *alert = new BAlert ("NetError", errString.String (), "OK", NULL, NULL, B_WIDTH_FROM_LABEL, B_WARNING_ALERT);
	alert->Go ();
	fHostIP.Truncate (0, true);
	fHostName.Truncate (0, true);
	for ( int x = 0; x < 6; x++ ) {
		fHostAliases[x].Truncate (0, true);
	}
	fTextField->SetText (NULL);
}

void NetWindow::NetDebug (const char *text, const char *extra) {
	BString		debugString (text);
	
	debugString << " " << extra;	
	BAlert *alert = new BAlert ("NetDebug", debugString.String (), "Sure", NULL, NULL, B_WIDTH_FROM_LABEL, B_INFO_ALERT);
	alert->Go ();
}