#include "NetTool.h"


void NetWindow::GetIP (const char *hostname, bool errfail)
{
	struct	in_addr	addr;
	struct	hostent	*host;

	fHostInfo = new BNetAddress (hostname, 0);
	if ( fHostInfo->InitCheck () == B_OK ) {
		if ( fHostInfo->GetAddr(addr, NULL) == B_OK ) {
			fHostIP.SetTo (inet_ntoa (addr));
			fHostName.SetTo (hostname);
			uint32	ip = inet_addr(fHostIP.String());
			host = gethostbyaddr ((char *)&ip, 4, AF_INET);
			if ( host ) {
				for ( int x = 0; x < 6; x++ ) {
					if ( host->h_aliases[x] == NULL ) {
						fHostAliases[x].Truncate (0, true);
					} else {
						fHostAliases[x].SetTo (host->h_aliases[x]);
					}
					if ( host->h_addr_list[x] == NULL ) {
						fHostAddresses[x].Truncate (0, true);
					} else {
						fHostAddresses[x].SetTo (host->h_addr_list[x]);
					}
				}
			}
		} else {
			fHostName.SetTo (hostname);
			fHostIP.Truncate (0, true);
			if ( errfail == true ) {
				NetError (hostname);
			}
		}
	} else {
		NetError (hostname);
	}
}

void NetWindow::GetName (const char *hostip, bool errfail)
{
	struct	hostent	*host;
	char			hostname[MAXHOSTNAMELEN];

	fHostInfo = new BNetAddress (inet_addr (hostip), 0);
	if ( fHostInfo->InitCheck () == B_OK ) {
		if ( fHostInfo->GetAddr (hostname, 0) == B_OK ) {
			uint32	ip = inet_addr(hostname);
			host = gethostbyaddr ((char *)&ip, 4, AF_INET);
			if ( host ) {
				fHostName.SetTo (host->h_name);
				fHostIP.SetTo (hostip);
//				for ( int x = 0; host->h_aliases[x] != NULL; x++ ) {
//					fHostAliases[x].SetTo (host->h_aliases[x]);
//					x++;
//				}
				for ( int x = 0; x < 6; x++ ) {
					if ( host->h_aliases[x] == NULL ) {
						fHostAliases[x].Truncate (0, true);
					} else {
						fHostAliases[x].SetTo (host->h_aliases[x]);
					}
					if ( host->h_addr_list[x] == NULL ) {
						fHostAddresses[x].Truncate (0, true);
					} else {
						fHostAddresses[x].SetTo (host->h_addr_list[x]);
					}
				}
			} else {
				fHostName.Truncate (0, true);
				fHostIP.SetTo (hostip);
				if ( errfail == true ) {
					NetError (hostname);
				}
			}
		} else {
			NetError (hostip);
		}
	} else {
		NetError (hostip);
	}
}
