#include "NetTool.h"

thread_id		udpscan_thread = 0;

int32 UDPThread ( void *data ) {
	BString			host ((char *)data);
	BNetAddress		*tHostInfo;
	BNetEndpoint	*target;
	thread_id		caller;
	BMessage		*aMessage = new BMessage(PORTFOUND_MSG);
	int				sbpos = 0;
	int				newsbpos = 0;
	int				start, end;
	char			recvbuf[1024];
	bool			sendmsg = false;
	char			buffer[256];
	
	memset (recvbuf, 0, sizeof(recvbuf));
	receive_data ( &caller, recvbuf, sizeof(recvbuf) );
	start = atoi (recvbuf);
	
	memset (recvbuf, 0, sizeof(recvbuf));
	receive_data ( &caller, &recvbuf, sizeof(recvbuf) );
	end = atoi (recvbuf);

	tHostInfo = new BNetAddress (inet_addr(host.String()), 0);
	if ( tHostInfo->InitCheck() != B_OK ) {
		return B_ERROR;
	}
	for ( int32 x = start; x < end+1; x++ ) {
		if ( sendmsg == true ) {
			sendmsg = false;
			aMessage = new BMessage(PORTFOUND_MSG);
		}
		newsbpos = (int)(((double)x/(double)end)*100);
		if ( newsbpos > (sbpos+1) ) {
			aMessage->AddInt8 ("sbupdate", (newsbpos-sbpos));
			sendmsg = true;
			sbpos = newsbpos;
		}
		tHostInfo->SetTo (inet_addr(host.String()), x); 
		target = new BNetEndpoint (SOCK_DGRAM);
		if ( target->InitCheck () == B_OK ) {
			target->SetNonBlocking (true);
			target->SetTimeout (1000);
			if ( target->Bind (2411) == B_OK ) {
				if ( target->Connect (*tHostInfo) == B_OK ) {
					target->Send ("\n", strlen("\n"), 0);
					snooze (20000);
					if ( target->Receive (buffer, 256, 0) > 0 ) {
						aMessage->AddInt32 ("portnum", x);
						aMessage->AddInt8 ("istcp", -1);
						sendmsg = true;
						target->Close ();
					}
				}
			target->Close ();
			}
		}
		if ( sendmsg == true ) {
			be_app->PostMessage (aMessage);
		}
	}
	BMessage	*bMessage = new BMessage (THREAD_EXIT);
	bMessage->AddInt8 ("istcp", -1);
	be_app->PostMessage (bMessage);
return B_OK;
}

bool NetWindow::KillUDPScanner () {
	if ( kill_thread (udpscan_thread) == B_OK ) {
		return true;
	}
return false;
}

void NetWindow::SpawnUDPScanner () {
	char	sendbuf[1024];
	
	udpscan_thread = spawn_thread (UDPThread, "UDPScan", B_NORMAL_PRIORITY, (void *)fHostIP.String());
	memset (sendbuf, 0, sizeof(sendbuf));
	sprintf (sendbuf, "%i", start_port);
	send_data (udpscan_thread, 420, sendbuf, strlen(sendbuf));
	resume_thread (udpscan_thread);
	memset (sendbuf, 0, sizeof(sendbuf));
	sprintf (sendbuf, "%i", end_port);
	send_data (udpscan_thread, 840, sendbuf, strlen(sendbuf));
}